
//////////////////////////////////////////////
// ---------------> Message

#include <boost/serialization/serialization.hpp>
#include <boost/serialization/base_object.hpp>
#include <boost/serialization/assume_abstract.hpp>

class Message {
	friend class boost::serialization::access;
public:
	Message() : type(123) {
	}

	virtual ~Message(){
	}

	virtual void virtualfunc () = 0;

private:
	int type;
	
	template<class Archive>
	void serialize(Archive& x, const unsigned int version){
		x & type;
	}
};

BOOST_SERIALIZATION_ASSUME_ABSTRACT(Message);

//////////////////////////////////////////////
// ----------------> MessageTimer

#include <boost/serialization/string.hpp>

using std::string;

class MessageTimer : public Message {
	friend class boost::serialization::access;
public:
	MessageTimer(int x) : event(x){
	}

	MessageTimer() : event(0){
	}

	virtual ~MessageTimer(){
	}
	
	virtual void virtualfunc(){
	}
	
private:
	int event;

	template<class Archive>
	void serialize(Archive& y, const unsigned int version){
		boost::serialization::base_object<Message>(*this);
		boost::serialization::void_cast_register<MessageTimer, Message> ();
		y & event;
	}
};

//////////////////////////////////////////////
// ----------------> Serialization

#include <iostream>
#include <sstream>
#include <ios>
#include <boost/archive/polymorphic_binary_oarchive.hpp>
#include <boost/archive/polymorphic_binary_iarchive.hpp>
#include <boost/serialization/utility.hpp> 
#include <boost/serialization/serialization.hpp> 
#include <boost/serialization/tracking.hpp>	
#include <boost/serialization/base_object.hpp>
#include <boost/serialization/export.hpp>
#include <boost/serialization/factory.hpp>


///////// COMMENT THE NEXT LINE TO MAKE IT COMPILE!!!
BOOST_CLASS_EXPORT(MessageTimer);
///////////////////////////////////////////////////////

BOOST_CLASS_TRACKING(MessageTimer, boost::serialization::track_never);

int main(){

	Message* msg = new MessageTimer( 5 );

	std::stringstream archiveStream (std::ios_base::binary | std::ios_base::out);
	{
	    boost::archive::polymorphic_binary_oarchive	outputArchive (archiveStream);
	    outputArchive & msg;
	}

	string data= archiveStream.str	();
	std::cout << data << std::endl;	

	return 0;
}
